use std::net::SocketAddr;

use axum::{routing, Router};

pub struct Server {
    app: Router,
    addr: SocketAddr,
}

impl Server {
    pub fn new() -> Server {
        let app = Router::new().route("/", routing::get(root));
        let addr = SocketAddr::from(([127, 0, 0, 1], 3000));

        return Server { app, addr };
    }

    pub async fn start(self) -> anyhow::Result<()> {
        tracing::info!("listening on {}", self.addr);

        match axum::Server::bind(&self.addr)
            .serve(self.app.into_make_service())
            .await
        {
            Ok(_) => Ok(()),
            Err(e) => Err(e.into()),
        }
    }
}

async fn root() -> &'static str {
    tracing::info!("some prae");
    return "PRAE";
}
